Option Explicit On 
Option Strict On

Imports Microsoft.Uddi
Imports Microsoft.Uddi.Business
Imports Microsoft.Uddi.Service
Imports Microsoft.Uddi.Binding
Imports Microsoft.Uddi.ServiceType
Imports Microsoft.Uddi.Api

'*********************************************************
'This project was ported to Visual Basic .NET from the 
'Microsoft Uddi.Samples.sln C# demonstration application
'Running this project requires the UDDI .NET SDK Beta 1.76
'The only changes are to form and control names, 
'and removal of exception handling for debugging purposes
'*********************************************************

Public Class frmUddi
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

   Public Sub New()
      MyBase.New()

      'This call is required by the Windows Form Designer.
      InitializeComponent()
      trvUddi.HotTracking = True
      With cboRegistry
         .Items.Add("http://uddi.microsoft.com/inquire")
         .Items.Add("http://test.uddi.microsoft.com/inquire")
         .Items.Add("http://www-3.ibm.com/services/uddi/inquiryapi")
         .SelectedIndex = 0
      End With
    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
   Friend WithEvents btnSubmit As System.Windows.Forms.Button
   Friend WithEvents txtSearch As System.Windows.Forms.TextBox
   Friend WithEvents cboRegistry As System.Windows.Forms.ComboBox
   Friend WithEvents lblRegistry As System.Windows.Forms.Label
   Friend WithEvents lblSearch As System.Windows.Forms.Label
   Friend WithEvents optBusName As System.Windows.Forms.RadioButton
   Friend WithEvents optTModel As System.Windows.Forms.RadioButton
   Friend WithEvents ttUddi As System.Windows.Forms.ToolTip
   Friend WithEvents trvUddi As System.Windows.Forms.TreeView
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
Me.components = New System.ComponentModel.Container()
Me.txtSearch = New System.Windows.Forms.TextBox()
Me.cboRegistry = New System.Windows.Forms.ComboBox()
Me.btnSubmit = New System.Windows.Forms.Button()
Me.trvUddi = New System.Windows.Forms.TreeView()
Me.optBusName = New System.Windows.Forms.RadioButton()
Me.optTModel = New System.Windows.Forms.RadioButton()
Me.lblRegistry = New System.Windows.Forms.Label()
Me.lblSearch = New System.Windows.Forms.Label()
Me.ttUddi = New System.Windows.Forms.ToolTip(Me.components)
Me.SuspendLayout()
'
'txtSearch
'
Me.txtSearch.Location = New System.Drawing.Point(72, 48)
Me.txtSearch.Name = "txtSearch"
Me.txtSearch.Size = New System.Drawing.Size(208, 20)
Me.txtSearch.TabIndex = 0
Me.txtSearch.Text = "OakLeaf"
Me.ttUddi.SetToolTip(Me.txtSearch, "Type the search term here")
'
'cboRegistry
'
Me.cboRegistry.Location = New System.Drawing.Point(72, 16)
Me.cboRegistry.Name = "cboRegistry"
Me.cboRegistry.Size = New System.Drawing.Size(208, 21)
Me.cboRegistry.TabIndex = 1
Me.cboRegistry.Text = "cboRegistry"
Me.ttUddi.SetToolTip(Me.cboRegistry, "Select the public registry to query")
'
'btnSubmit
'
Me.btnSubmit.Location = New System.Drawing.Point(358, 14)
Me.btnSubmit.Name = "btnSubmit"
Me.btnSubmit.Size = New System.Drawing.Size(72, 24)
Me.btnSubmit.TabIndex = 2
Me.btnSubmit.Text = "&Submit"
Me.ttUddi.SetToolTip(Me.btnSubmit, "Click to submit search term")
'
'trvUddi
'
Me.trvUddi.ImageIndex = -1
Me.trvUddi.Location = New System.Drawing.Point(16, 88)
Me.trvUddi.Name = "trvUddi"
Me.trvUddi.SelectedImageIndex = -1
Me.trvUddi.Size = New System.Drawing.Size(488, 296)
Me.trvUddi.TabIndex = 3
'
'optBusName
'
Me.optBusName.Checked = True
Me.optBusName.Location = New System.Drawing.Point(305, 51)
Me.optBusName.Name = "optBusName"
Me.optBusName.Size = New System.Drawing.Size(101, 16)
Me.optBusName.TabIndex = 4
Me.optBusName.TabStop = True
Me.optBusName.Text = "Business Name"
Me.ttUddi.SetToolTip(Me.optBusName, "Search business entities")
'
'optTModel
'
Me.optTModel.Location = New System.Drawing.Point(416, 51)
Me.optTModel.Name = "optTModel"
Me.optTModel.Size = New System.Drawing.Size(88, 16)
Me.optTModel.TabIndex = 5
Me.optTModel.Text = "tModel URN"
'
'lblRegistry
'
Me.lblRegistry.Location = New System.Drawing.Point(8, 18)
Me.lblRegistry.Name = "lblRegistry"
Me.lblRegistry.Size = New System.Drawing.Size(64, 16)
Me.lblRegistry.TabIndex = 6
Me.lblRegistry.Text = "Registry:"
Me.lblRegistry.TextAlign = System.Drawing.ContentAlignment.TopRight
'
'lblSearch
'
Me.lblSearch.Location = New System.Drawing.Point(8, 50)
Me.lblSearch.Name = "lblSearch"
Me.lblSearch.Size = New System.Drawing.Size(64, 16)
Me.lblSearch.TabIndex = 7
Me.lblSearch.Text = "Search for:"
Me.lblSearch.TextAlign = System.Drawing.ContentAlignment.TopRight
'
'frmUddi
'
Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
Me.ClientSize = New System.Drawing.Size(520, 397)
Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.lblSearch, Me.lblRegistry, Me.optTModel, Me.optBusName, Me.trvUddi, Me.btnSubmit, Me.cboRegistry, Me.txtSearch})
Me.MaximizeBox = False
Me.Name = "frmUddi"
Me.Text = "UDDI Explorer - Visual Basic .NET Version Ported from Microsoft C# Code"
Me.ttUddi.SetToolTip(Me, "Search tModels")
Me.ResumeLayout(False)

    End Sub

#End Region

   Private Sub btnSubmit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSubmit.Click
      ' Set the URL of the UDDI Registry to search
      Inquire.AuthenticationMode = AuthenticationMode.UddiAuthentication
      Inquire.Url = cboRegistry.SelectedItem.ToString()
      ' What are we searching for?  Business or tModel
      If optBusName.Checked = True Then
         Call find_business()
      Else
         Call find_tmodel()
      End If
   End Sub

   '**************************************
   'Business and businessDetail operations
   '**************************************

   Private Sub find_business()
      ' Construct a find_business message
      Dim bl As BusinessList
      Dim d As Description
      Dim bi As BusinessInfo
      Dim si As ServiceInfo

      trvUddi.BeginUpdate()
      Dim fb As New FindBusiness()
      fb.Name = txtSearch.Text
      bl = fb.Send()
      trvUddi.Nodes.Clear()

      If bl.BusinessInfos.Count = 0 Then
         trvUddi.Nodes.Add(New TreeNode("No Businesses were found"))
      Else
         ' Add information about businesses found to tree
         For Each bi In bl.BusinessInfos
            trvUddi.Nodes.Add(New TreeNode(bi.Name))
            If bi.Descriptions.Count > 0 Then
               trvUddi.Nodes(bl.BusinessInfos.IndexOf(bi)).Nodes.Add(New TreeNode("Descriptions(" + CStr(bi.Descriptions.Count) + ")"))
               For Each d In bi.Descriptions
                  ' Adding descriptions
                  trvUddi.Nodes(bl.BusinessInfos.IndexOf(bi)).Nodes(0).Nodes.Add(d.Text)
               Next d
            End If
            If bi.ServiceInfos.Count > 0 Then
               ' Adding info about services exposed by the business
               trvUddi.Nodes(bl.BusinessInfos.IndexOf(bi)).Nodes.Add(New TreeNode("Services" + "(" + CStr(bi.ServiceInfos.Count) + ")"))
               For Each si In bi.ServiceInfos
                  trvUddi.Nodes(bl.BusinessInfos.IndexOf(bi)).Nodes(1).Nodes.Add(si.Name)
                  trvUddi.Nodes(bl.BusinessInfos.IndexOf(bi)).Nodes(1).Nodes(bi.ServiceInfos.IndexOf(si)).Tag = si.ServiceKey
               Next si
            End If
         Next
      End If
      trvUddi.EndUpdate()
   End Sub

   Private Sub get_serviceDetail()
      ' Construct a get_serviceDetail message and retrieve service
      Dim sd As ServiceDetail
      Dim service As BusinessService
      Dim d As Description
      Dim bt As BindingTemplate
      Dim desc As Description
      Dim tmii As TModelInstanceInfo
      Dim tn1 As TreeNode

      Dim gsd As New GetServiceDetail()
      gsd.ServiceKeys.Add(trvUddi.SelectedNode.Tag.ToString())
      sd = gsd.Send()

      For Each service In sd.BusinessServices
         ' Show service descriptions
         Dim tn As New TreeNode("Descriptions(" + CStr(service.Descriptions.Count) + ")")

         For Each d In service.Descriptions
            tn.Nodes.Add(d.Text)

            trvUddi.SelectedNode.Nodes.Add(tn)
            ' Show binding template information

            tn1 = New TreeNode()
            tn1.Text = "Bindings(" + CStr(service.BindingTemplates.Count) + ")"

            For Each bt In service.BindingTemplates
               Dim tn2 As New TreeNode()
               For Each desc In bt.Descriptions
                  tn2.Text = desc.Text
                  If Not bt.AccessPoint Is Nothing Then
                     tn2.Nodes.Add(bt.AccessPoint.URLType.ToString())
                     tn2.Nodes(0).Nodes.Add(bt.AccessPoint.Text)
                  End If

                  If bt.TModelInstanceDetail.TModelInstanceInfos.Count > 0 Then
                     tn2.Nodes.Add("Binding Signatures(" + CStr(bt.TModelInstanceDetail.TModelInstanceInfos.Count) + ")")
                     For Each tmii In bt.TModelInstanceDetail.TModelInstanceInfos
                        tn2.Nodes(1).Nodes.Add(tmii.TModelKey)
                     Next tmii
                     tn1.Nodes.Add(tn2)
                  End If
               Next desc
            Next bt
         Next d
         trvUddi.SelectedNode.Nodes.Add(tn1)
      Next service
   End Sub

   Private Sub trvUddi_AfterSelect(ByVal sender As System.Object, ByVal e As System.Windows.Forms.TreeViewEventArgs) Handles trvUddi.AfterSelect
      If Not trvUddi.SelectedNode.Tag Is Nothing Then
         If optBusName.Checked = True Then
            get_serviceDetail()
         Else
            get_tmodelDetail()
         End If
      End If
   End Sub

   '**********************************
   'tModel and tModelDetail Operations
   '**********************************

   Private Sub find_tmodel()
      ' Construct a find_tModel message
      Dim tml As TModelList
      Dim tmi As TModelInfo
      trvUddi.BeginUpdate()
      Dim ftm As New FindTModel()
      ftm.Name = txtSearch.Text
      tml = ftm.Send()
      trvUddi.Nodes.Clear()

      If tml.TModelInfos.Count = 0 Then
         trvUddi.Nodes.Add(New TreeNode("No tModels were found"))
      Else
         ' Add information to tree
         For Each tmi In tml.TModelInfos
            trvUddi.Nodes.Add(tmi.Name)
            trvUddi.Nodes(tml.TModelInfos.IndexOf(tmi)).Tag = tmi.TModelKey
         Next
      End If
      trvUddi.EndUpdate()
   End Sub

   Private Sub get_tmodelDetail()
      ' Construct a get_tModelDetail message and retrieve the tmodel
      Dim gtmd As New GetTModelDetail()
      Dim tmd As TModelDetail
      Dim tm As TModel
      Dim d As Description
      Dim d1 As Description

      gtmd.TModelKeys.Add(trvUddi.SelectedNode.Tag.ToString())
      tmd = gtmd.Send()
      ' Show the details with all tModels
      For Each tm In tmd.TModels
         ' Show all descriptions
         Dim tn As New TreeNode("Descriptions(" + CStr(tm.Descriptions.Count) + ")")
         For Each d In tm.Descriptions
            tn.Nodes.Add(d.Text)
            ' Show overview document descriptions
            Dim tn1 As New TreeNode("Overview Document")
            For Each d1 In tm.OverviewDoc.Descriptions
               tn1.Nodes.Add(d1.Text)
            Next d1
            ' Show overview url
            tn1.Nodes.Add(tm.OverviewDoc.OverviewURL)
            trvUddi.SelectedNode.Nodes.Add(tn)
            trvUddi.SelectedNode.Nodes.Add(tn1)
         Next d
      Next tm
   End Sub
End Class
